/* lib/parsedba.p
 *
 */

{lib/dba.i}

{lib/protop.i}

define new global shared variable dbgMode as integer no-undo initial 1.

define variable r          as integer   no-undo.
define variable x          as character no-undo.
define variable y          as decimal   no-undo.
define variable z          as decimal   no-undo.
define variable xline      as character no-undo extent 64.
define variable curr_area  as character no-undo.
define variable doFixed    as logical   no-undo initial no.
define variable bSize      as integer   no-undo initial 4096.

define variable ztblName   as character no-undo.
define variable zidxName   as character no-undo.
define variable zlobName   as character no-undo.

define variable db_analx   as character no-undo.

define variable db_recid   as recid     no-undo.

define stream tba.		/* input table analysis	*/

/*** main block (constructor)
 ***
 ***/

session:add-super-procedure( this-procedure ).

return.


function getDecimal returns decimal ( numString as character ):

  define variable x as decimal no-undo.

  case substring( numString, length( numString ), 1 ):

    when "T" then  x = decimal( substring( numString, 1, length( numString ) - 1 )) * 1024 * 1024 * 1024 * 1024.  /* 1,099,511,627,776 */
    when "G" then  x = decimal( substring( numString, 1, length( numString ) - 1 )) * 1024 * 1024 * 1024.         /*     1,073,741,824 */
    when "M" then  x = decimal( substring( numString, 1, length( numString ) - 1 )) * 1024 * 1024.                /*         1,048,576 */
    when "K" then  x = decimal( substring( numString, 1, length( numString ) - 1 )) * 1024.                       /*              1024 */
    when "B" then  x = decimal( substring( numString, 1, length( numString ) - 1 )).

    otherwise      x = decimal( numString ).

  end.

  return x.

end.


procedure RecBlkSum:

  /* 
   *	RECORD BLOCK SUMMARY FOR AREA "Employee" : 7
   *	-------------------------------------------------------
   *	                                       -Record Size (B)- ---Fragments--- Scatter
   *	Table                Records    Size   Min   Max  Mean      Count Factor  Factor
   *	PUB.Benefits              21  848.0B    39    41    40         21    1.0     1.0
   *	PUB.Department             7  211.0B    26    35    30          7    1.0     2.0
   *	PUB.Employee              55    6.2K    99   135   115         55    1.0     1.0
   *	PUB.Family                72    3.1K    38    51    44         72    1.0     1.0
   *	PUB.TimeSheet             25    1.1K    42    45    43         25    1.0     1.0
   *	PUB.Vacation              12  288.0B    24    24    24         12    1.0     1.0
   *	
   *	                    ------------------------------------------------------------
   *	Subtotals:               192   11.7K    24   135    62        192    1.0     1.2
   */

  area_block:
  repeat on error undo, leave on endkey undo, leave:

    curr_area = xline[6].							/* area name 					*/

    if dbgMode >= 4 then message now "Parsing Record Block Summary for Area: [" curr_area "] " view-as alert-box.

    tables:
    repeat:

      xline = ?.
      do  on error undo, leave area_block on endkey undo, leave area_block:
        import stream tba xline.
      end.

      if xline[1] = ? or xline[1] = "" then next tables.

      if xline[1] = "Subtotals:" then
        do:
          return.								/* end of table data for this storage area	*/
        end.
       else if xline[1] = "INDEX" and xline[2] = "BLOCK" and xline[3] = "SUMMARY" then
        do:
          message "index block summary inside record block summary!" "current:" curr_area "new:" xline[6] view-as alert-box.
          run IdxBlkSum.
          return.								/* this shouldn't happen			*/
        end.
       else if xline[1] = "SUMMARY" and xline[2] = "FOR" and xline[3] = "AREA" then
        do:
          return.								/* this shouldn't happen			*/
        end.
       else if xline[1] = "RECORD" and xline[2] = "BLOCK" and xline[3] = "SUMMARY" and xline[4] = "FOR" and xline[5] = "AREA" then
        do:
          next area_block.							/* this shouldn't happen			*/
        end.

      /* process data for a table
       */

      if xline[1] begins "PUB." then
        do:

          find tblist where tblist.tbl = substring( xline[1], 5 ) no-error.
          if not available( tblist ) then
            do:
              create tblist.
              assign
                tblist.tbl = trim( substring( xline[1], 5 ))
              .
            end.

          tblist.ar  = curr_area.

          if xline[2] <> ? and xline[2] <> "" then				/* test for a broken line			*/
            do:
              assign								/* normal line					*/
                tblist.recs = tblist.recs + getDecimal( xline[2] )
                tblist.tsz  = tblist.tsz  + getDecimal( xline[3] )		/* what is with the "+"???  these should all be simple assignments shouldn't they? */
                tblist.frag = tblist.frag + getDecimal( xline[7] )
                tblist.scat = tblist.scat + getDecimal( xline[9] )
              no-error.
            end.
           else									/* the line was broken -- record count etc	*/
            do:									/* are on the next line				*/
              import stream tba xline.
              assign
                tblist.recs = tblist.recs + getDecimal( xline[1] )
                tblist.tsz  = tblist.tsz  + getDecimal( xline[2] )
                tblist.frag = tblist.frag + getDecimal( xline[6] )
                tblist.scat = tblist.scat + getDecimal( xline[8] )
              no-error.
            end.

          /* need a connected db with access to _file etc for the remaining details
           */

          find first _file no-lock where _file-name = tblist.tbl no-error.
          if not available _file then
            do:
              if dbgMode >= 4 then message now "recBlkSum() No such table as:" tblist.tbl view-as alert-box.
              next tables.
            end.

          tblist.tid = _file-num.

          find first _storageObject no-lock where
               _storageObject._Db-recid = db_recid and
               _Object-type = 1 and
               _Object-number = _File-Number
            no-error.

          if not available( _storageObject ) then
            do:
              message now "recBlkSum() Ambiguous:" ambiguous(_storageObject ) tblist.tbl _file-number xLine[1] xLine[2] xLine[3] xLine[4] xLine[5] xLine[6] view-as alert-box.
              next tables.
            end.

          tblist.b2  = ( get-bits( _object-attrib, 7, 1 ) = 1 ).

        end.

    end.

  end.

  return.

end.


procedure IdxBlkSum:

  /*
   *	INDEX BLOCK SUMMARY FOR AREA "LogData_Idx" : 21
   *	-------------------------------------------------------
   *	Table                      Index  Fields Levels  Blocks    Size   % Util Factor
   *	PUB.logdata
   *	  db_metric_dt-idx            11       3      4  3648565   15.7G    56.5     1.9
   *	  log-idx                     10       4      4  4041143   17.5G    56.9     1.9
   *	  metric-idx                  12       2      4  1109124    4.5G    53.0     1.9
   */

  curr_area = xline[6].							/* area name */

  if dbgMode >= 4 then message now "Parsing Index Block Summary for Area: [" curr_area "] " xline[6] view-as alert-box.

  idx_area_block:
  repeat on error undo, leave on endkey undo, leave:

    indexes:
    repeat:

      xline = ?.
      do  on error undo, leave idx_area_block on endkey undo, leave idx_area_block:
        import stream tba xline.
      end.

      if xline[1] = ? or xline[1] = "" then next indexes.

      if xline[1] = "Subtotals:" then
        do:
          return.
        end.
       else if xline[1] = "RECORD" and xline[2] = "BLOCK" and xline[3] = "SUMMARY" then
        do:
          return.
        end.
       else if xline[1] = "SUMMARY" and xline[2] = "FOR" and xline[3] = "AREA" then
        do:
          return.
        end.
       else if xline[1] = "RECORD" and xline[2] = "BLOCK" and xline[3] = "SUMMARY" and xline[4] = "FOR" and xline[5] = "AREA" then
        do:
          message "record block summary inside index block summary!" "current:" curr_area "new:" xline[6] view-as alert-box.
          run RecBlkSum.
          return.
        end.

      if xline[1] begins "PUB." then					/* we have a table... 				*/
        idx_loop: do while xline[1] begins "PUB.":

          ztblName = substring( xline[1], 5 ).

          /* read some index data... */

          repeat:

            xline = ?.
            do  on error undo, leave idx_area_block on endkey undo, leave idx_area_block:

              import stream tba xline.

              if       xline[1] begins "PUB." then next idx_loop.
               else if xline[1] = ? then return.

              zidxname = ztblName + "." + xline[1].

              find ixlist where ixlist.idx = zidxName no-error.
              if not available ixlist then
                do:
                  create ixlist.
                  assign
                    ixlist.ar    = curr_area
                    ixlist.idx   = zidxName
                    ixlist.blks  = decimal( xline[5] )
                    ixlist.pctut = decimal( xline[7] )
                    ixlist.lvls  = decimal( xline[4] )
                  no-error.
                end.

            end.

          end.

          end.

    end.    /* repeat indexes... */

  end.

  return.

end.


procedure LOBSum:

  /* note the lack of quoting for the area name :(
   *
   * LOB SUMMARY FOR AREA Schema Area: 6
   * 
   * 
   * LOB SUMMARY FOR SHARED TABLES:                                    
   * ----------------------------------------------
   * 
   * Table                                       LOBs     Size      Min      Max     Mean
   * PUB._Collation:-69
   *     _Coll-CIData:4                             0     0.0B     0.0B     0.0B     0.0B
   *     _Coll-CSData:3                             0     0.0B     0.0B     0.0B     0.0B
   *     _Coll-CXData:5                             0     0.0B     0.0B     0.0B     0.0B
   * PUB._Field-Trig:-66
   *     _Rcode:2                                   0     0.0B     0.0B     0.0B     0.0B
   * PUB._File-Trig:-65
   *     _Rcode:1                                   0     0.0B     0.0B     0.0B     0.0B
   * PUB._Sysautostats:-127
   *     _Misc:6                                    0     0.0B     0.0B     0.0B     0.0B
   *                                  -----------------------------------------------------------------------------
   * Subtotals:                                     0     0.0B     0.0B     0.0B     0.0B
   * 
   * Summary for AREA "Schema Area": 6
   *                                  -----------------------------------------------------------------------------
   * Subtotals:                                     0     0.0B     0.0B     0.0B     0.0B
   *
   *
   * LOB SUMMARY FOR AREA Lobs: 9
   *                                   
   * 
   * LOB SUMMARY FOR SHARED TABLES:
   * ----------------------------------------------
   * 
   *     
   *                                                                ---    LOB Size   ---
   * Table                                       LOBs     Size      Min      Max     Mean
   * PUB.Country:4
   *     CountryFlag:5                             15    18.5K   978.0B     2.0K     1.2K
   * PUB.Salesrep:19
   *     LargeImage:7                               9   202.2K    16.2K    28.3K    22.5K
   *     SmallImage:6                               9    34.7K     1.7K     5.1K     3.9K
   *                                  -----------------------------------------------------------------------------
   * Subtotals:                                    33   255.4K   978.0B    28.3K     7.7K
   *
   */

  define variable i as integer no-undo initial 6.

  curr_area = xline[i].							/* area name */
  do while num-entries( curr_area, ":" ) < 2 and i < 16:
    i = i + 1.
    curr_area = curr_area + " " + xline[i].
  end.

  curr_area = trim( curr_area, ":" ).

  if dbgMode >= 4 then message now "Parsing LOB Summary for Area: [" curr_area "] " xline[6] view-as alert-box.

  lob_area_block:
  repeat on error undo, leave on endkey undo, leave:

    lobs:
    repeat:

      xline = ?.
      do  on error undo, leave lob_area_block on endkey undo, leave lob_area_block:
        import stream tba xline.
      end.

      if xline[1] = ? or xline[1] = "" or xline[1] begins "----" then next lobs.

      if xline[1] = "Subtotals:" then
        do:
          return.
        end.

/*
Table                                       LOBs     Size      Min      Max     Mean
PUB._Collation:-69
    _Coll-CIData:4                             0     0.0B     0.0B     0.0B     0.0B
    _Coll-CSData:3                             0     0.0B     0.0B     0.0B     0.0B
    _Coll-CXData:5                             0     0.0B     0.0B     0.0B     0.0B
PUB._Field-Trig:-66
    _Rcode:2                                   0     0.0B     0.0B     0.0B     0.0B
PUB._File-Trig:-65
    _Rcode:1                                   0     0.0B     0.0B     0.0B     0.0B
PUB._Sysautostats:-127
    _Misc:6                                    0     0.0B     0.0B     0.0B     0.0B
                                 -----------------------------------------------------------------------------
Subtotals:                                     0     0.0B     0.0B     0.0B     0.0B
 */

      if xline[1] begins "PUB." then					/* we have a table... 				*/
        lob_loop: do while xline[1] begins "PUB.":

          ztblName = substring( xline[1], 5 ).
          ztblName = entry( 1, ztblName, ":" ).

          if ztblName begins "---" then next lob_loop.

          /* read some LOB data... */

          repeat:

            xline = ?.
            do  on error undo, leave lob_area_block on endkey undo, leave lob_area_block:

              import stream tba xline.

              if       xline[1] begins "PUB." then next lob_loop.
               else if xline[1] begins "----" then next lob_loop.
               else if xline[1] begins "Subt" then next lob_loop.
               else if xline[1] = ? then return.

              zlobname = ztblName + "." + entry( 1, trim( xline[1] ), ":" ).

              find lxlist where lxlist.lob = zlobName no-error.
              if not available lxlist then
                do:
                  create lxlist.
                  assign
                    lxlist.ar     = curr_area
                    lxlist.lob    = zlobName
                  no-error.				/* 10.1B issue :(	*/
                  assign
                    lxlist.recs   = getDecimal( xline[2] )
                    lxlist.lsz    = getDecimal( xline[3] )
                    lxlist.minLOB = getDecimal( xline[4] )
                    lxlist.maxLOB = getDecimal( xline[5] )
                    lxlist.avgLOB = getDecimal( xline[6] )
                  no-error.
                end.

            end.

          end.

          end.

    end.    /* repeat lobs... */

  end.

  return.

end.


procedure RMChain:

  /* oe10
   *
   * 	RM CHAIN ANALYSIS
   * 	-----------------
   * 
   * 	3 block(s) found in the RM chain of Table object 1
   * 
   * 	20 block(s) found in the RM chain of Table object 3
   *
   *
   * oe11+
   * 
   * 	RM CHAIN ANALYSIS
   * 	---------------------------
   * 
   * 
   * 	Number of          Object    Object
   * 	Blocks             Type
   * 	------------------------------------------------------------------------------------------------------
   * 	60                 Table     PUB.Ar-token-facte:60   
   */

  if dbgMode >= 4 then message now "Parsing RM Chain Analysis" view-as alert-box.

  rm_chain_block:
  repeat on error undo, leave on endkey undo, leave:

    rm_chain:
    repeat:

      xline = ?.
      do  on error undo, leave rm_chain_block on endkey undo, leave rm_chain_block:
        import stream tba xline.
      end.

      if xline[1] = ? or xline[1] = "" then next rm_chain.

      if xline[1] begins "---" then
        do:

          if proversion >= "11" then next rm_chain.

          repeat:

            xline = ?.
            import stream tba xline.

            if xline[1] = ? or xline[1] = "" then next.

            if xline[2] = "block(s)" and xline[9] = "Table" then
              do:

                find first _file no-lock where _file-number = integer( xline[11] ) no-error.
                if not available _file then
                  do:
                    if dbgMode >= 4 then message now "rmChain() No such table as:" xline[11] view-as alert-box.
                    next.
                  end.

                create tblist.
                assign
                  tblist.tbl = _file._file-name
                  tblist.tid = _file-num
                  tblist.rm  = decimal( xline[1] )
                no-error.

              end.
             else leave.
          end.
          leave rm_chain_block.
        end.

      /* oe11 rm chain
       */

      if xline[1] = "Number" and xline[2] = "of" then
        do:

          if dbgMode >= 4 then message now "Parsing oe11 rm chain".

          import stream tba xline.
          if xline[1] = "Blocks" then
            do:
              import stream tba xline.
              if xline[1] begins "----" then
                rm_blocks: repeat:
                  xline = ?.
                  import stream tba xline.
                  if xline[1] = ? then return.
                  if xline[2] = "table" then
                    do:

                      find tblist where tblist.tbl = entry( 1, substring( xline[3], 5 ), ":" ) no-error.
                      if not available( tblist ) then
                        do:
                          create tblist.
                          assign
                            tblist.tbl = entry( 1, trim( substring( xline[3], 5 )), ":" )
                            /* tblist.ar  = curr_area */
                          .
                        end.

                      find first _file no-lock where _file-name = tblist.tbl no-error.
                      if not available _file then
                        do:
                          if dbgMode >= 4 then message now "rmChain() No such table as:" tblist.tbl view-as alert-box.
                          next rm_blocks.
                        end.

                      assign
                        tblist.tid = _file-num
                        tblist.rm = decimal( xline[1] )
                      no-error.

                    end.

                end. /* rm_blocks */

            end.

        end.

      return.

    end.

  end.

  return.

end.


procedure parseDBA:

  define input parameter db_anal as character no-undo.

  if dbgMode >= 2 then message now "Parsing:" db_anal.

  input stream tba from value( db_anal ).

  find first dictdb._Db no-lock.
  db_recid = recid( _db ).

  empty temp-table tblist.
  empty temp-table ixlist.

  tba:
  repeat on error undo, leave on endkey undo, leave:

    xline = ?.
    do  on error undo, leave tba on endkey undo, leave tba:
      import stream tba xline.
    end.

    if xline[1] = ? or xline[1] = "" then next tba.

    /* ok, we're reading the important stuff...
     */

    if       xline[1] = "RECORD" and xline[2] = "BLOCK" and xline[3] = "SUMMARY" and xline[4] = "FOR" and xline[5] = "AREA" then
      run RecBlkSum.
     else if xline[1] = "INDEX"  and xline[2] = "BLOCK" and xline[3] = "SUMMARY" and xline[4] = "FOR" and xline[5] = "AREA" then
      run IdxBlkSum.
     else if xline[1] = "LOB"                           and xline[2] = "SUMMARY" and xline[3] = "FOR" and xline[4] = "AREA" then
      run LOBSum.
     else if xline[1] = "RM"     and xline[2] = "CHAIN" and xline[3] = "ANALYSIS" then
      run RMChain.

  end.

  input stream tba close.

  if dbgMode >= 2 then message now "Done parsing dbanalys data".

  /* associate indexes and lobs with parent tables
   */

  for each tblist where tbl <> "":
    for each ixlist where entry( 1, ixlist.idx, "." ) = tblist.tbl:
      ixlist.iid = tblist.tid.
    end.
    for each lxlist where entry( 1, lxlist.lob, "." ) = tblist.tbl:
      lxlist.lid = tblist.tid.
    end.
  end.  

  db_analx = right-trim( search( db_anal ), "dba" ) + "dbx".			/* "." is treated like a wild-card?	*/

  output to value( db_analx ).
  for each tblist where tbl <> "":
    export tblist.
  end.
  output close.

  output to value( right-trim( db_analx, "dbx" ) + "idx" ).
  for each ixlist where idx <> "":
    export ixlist.
  end.
  output close.

  output to value( right-trim( db_analx, "dbx" ) + "lbx" ).
  for each lxlist where lob <> "":
    export lxlist.
  end.
  output close.

  return.

end.

procedure parseTableCSV:
  /* parse the table output file from proutil dbanalys -csoutput and populate temp-table tblist */
  
  /* Example (spaces added for clarity):
    "Time Stamp"                 "DBUID"                  "DB name"  "Area"         "Area #" "Partition Type" "Tenancy"     "Tenancy #" "Partition Policy" "Partition" "Partition #" "Owner" "Table"    "Table #" "Records" "Size" "Min" "Max" "Mean" "Frag Count" "Frag Factor" "Scatter Factor"
    2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Control Area"  1       "-"              "-"             0         "-"                "-"           0           "PUB"   "_Area"     -71        5         223   39    54    44      5           1.0           1.0
    ...                                                                                                                                                                                                                                                                           
    2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1"         7       "-"              "-"             0         "-"                "-"           0           "PUB"   "State"       5       51        1755   29    40    34     51           1.0           4.0
    2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "EastSports"    1         "-"                "-"           1           "PUB"   "Customer"    1       10         555   47    68    55     10           1.0           2.0
    2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "NorthSports"   3         "-"                "-"           3           "PUB"   "Customer"    1        5         249   41    57    49      5           1.0           8.0
    2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "NorthSports"   3         "-"                "-"           3           "PUB"   "Item"        2        3          92   30    31    30      3           1.0           5.0
    2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "SouthSports"   4         "-"                "-"           4           "PUB"   "Customer"    1        4         247   60    63    61      4           1.0           3.0
    2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "WestSports"    2         "-"                "-"           2           "PUB"   "Customer"    1        6         326   41    64    54      6           1.0           5.0
    2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "G"              "groupItem"    -1         "-"                "-"          -1           "PUB"   "Item"        2       55        1931   28    40    35     55           1.0           3.0
  */
  
  define input parameter tableCSVFile as character no-undo.     /* dbanalys/<pt_shortname>.tab.txt */
  
  define variable TimeStamp       as character no-undo. 
  define variable DBUID           as character no-undo. 
  define variable DB_name         as character no-undo. 
  define variable Area            as character no-undo. 
  define variable Area#           as integer   no-undo. 
  define variable PartitionType   as character no-undo. 
  define variable Tenancy         as character no-undo. 
  define variable Tenancy#        as integer   no-undo. 
  define variable PartitionPolicy as character no-undo.
  define variable Partition       as character no-undo. 
  define variable Partition#      as integer   no-undo. 
  define variable TableOwner      as character no-undo. 
  define variable TableName       as character no-undo. 
  define variable Table#          as integer   no-undo. 
  define variable Records         as integer   no-undo. 
  define variable TableSize       as integer   no-undo. 
  define variable RecMin          as integer   no-undo. 
  define variable RecMax          as integer   no-undo. 
  define variable RecMean         as integer   no-undo. 
  define variable FragCount       as integer   no-undo. 
  define variable FragFactor      as decimal   no-undo. 
  define variable ScatterFactor   as decimal   no-undo. 
  
  define variable totalScatWeight as decimal   no-undo.

  if dbgMode >= 2 then message now "Parsing:" tableCSVFile.
  
  input stream tba from value( tableCSVFile ).
  
  find first dictdb._Db no-lock.
  db_recid = recid( _db ).

  empty temp-table tblist.
  empty temp-table tt_MTScatter.
    
  repeat:
    
    import stream tba
      TimeStamp
      DBUID
      DB_name
      Area
      Area#
      PartitionType
      Tenancy
      Tenancy#
      PartitionPolicy
      Partition
      Partition#
      TableOwner
      TableName
      Table#
      Records
      TableSize
      RecMin
      RecMax
      RecMean
      FragCount
      FragFactor
      ScatterFactor
      no-error.
    
    /* if -verbose was used, there will be a header record with column labels that we want to skip */
    if TimeStamp = 'Time Stamp' then next.
    
    /* make sure this table is in the cache */
    find tt_tbl no-lock where tt_tbl.xid = Table# no-error.
    if not available( tt_tbl ) then
      do:
        if dbgMode >= 2 then message now substitute( "parseTableCSV: table # &1 &2 in CSV file was not found in cache tt_tbl", Table#, TableName ).
        next.
      end.
    
    find tblist no-lock where tblist.tbl = TableName no-error.
    if not available( tblist ) then
      do:
        create tblist.
        assign
          tblist.tid = Table#
          tblist.tbl = TableName
          tblist.ar  = Area
          .
      end. 
    
    /* if all partitions of a table are not in the same area, set the area name to "*" */
    if tblist.ar <> "*" then
      do:
        if tblist.ar <> Area then
          tblist.ar = "*". 
      end.   
    
    /* accumulate totals */
    assign
      tblist.recs = tblist.recs + Records
      tblist.tsz  = tblist.tsz  + TableSize
      tblist.frag = tblist.frag + FragCount
      .
    
    if tt_tbl.isMultiTenant then
      /* scatter factor, MT tables */
      do:
        create tt_MTScatter.
        assign
          tt_MTScatter.TblNumber  = Table#
          tt_MTScatter.TblName    = TableName
          tt_MTScatter.ScatWeight = ScatterFactor * Records
          .
      end.  
    
    else
      /* non-MT tables: they have only one record in the CSV file */
      do:
        assign
          tblist.scat = ScatterFactor
          tblist.b2   = ( tblPool = 'B2') 
          .
      end.    
      
    /* todo: determine MT table buffer pool residency */
    
    
  end.    /* repeat */
  
  input stream tba close.
  
  /* now that we have record, fragment, and size totals from all partitions in MT tables, we can calculate pctfrag and avgrec */
  for each tblist:
    
    if tblist.recs > 0 then
      assign
       tblist.pctfrag = (( tblist.frag / tblist.recs ) - 1 ) * 100
       tblist.avgrec  = tblist.tsz / tblist.recs
        .
        
  end.  
  
  /* calculate the weighted average of the scatter factors of the MT tables' partitions */
  for each tblist no-lock:
    
    find tt_tbl no-lock where tt_tbl.xid = tblist.tid no-error.
    if not available( tt_tbl ) then next.
    if not tt_tbl.isMultiTenant then next.

    if tblist.recs > 0 then
      do:
        totalScatWeight = 0.

        for each tt_MTScatter no-lock where tt_MTScatter.TblNumber = tblist.tid:
          totalScatWeight = totalScatWeight + tt_MTScatter.ScatWeight.
        end.  
    
        tblist.scat = totalScatWeight / tblist.recs.
      end.   
      
  end.
  
  /* export the temp-table to <pt_shortname>.dbx */
  db_analx = substring( tableCSVFile, 1, length( tableCSVFile ) - 8 ) + '.dbx'.

  output to value( db_analx ).
  for each tblist where tblist.tbl <> "":
    export tblist.
  end.
  output close.
  
end procedure.

procedure parseIndexCSV:
  /* parse the index output file from proutil dbanalys -csoutput and populate temp-table ixlist */
  
  /* Example (spaces added for clarity):
    "Time Stamp"                  "DBUID"                  "DB name"  "Area"         "Area #" "Partition Type" "Tenancy"     "Tenancy #" "Partition Policy" "Partition" "Partition #" "Owner" "Table"       "Table #" "Index"            "Index #" "State" "Fields" "Levels" "Blocks" "Size" "Utilization" "Factor"
     2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Control Area"  1       "-"              "-"             0         "-"                "-"           0           "PUB"   "_Area"        -71      "_Area-Number"      1027      1       1        1        1         52     1.3          1.0
     2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Control Area"  1       "-"              "-"             0         "-"                "-"           0           "PUB"   "_AreaExtent"  -72      "_AreaExtent-Area"  1028      1       2        1        1         62     1.5          1.0    
     ...                                                                                                                                                                                                                                                                                                  
     2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "EastSports"    1         "-"                "-"           1           "PUB"   "Customer"       1      "Custn"                8      1       1        1        1         97     2.4          1.0
     2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "EastSports"    1         "-"                "-"           1           "PUB"   "Customer"       1      "Name"                 9      1       1        1        1        251     6.2          1.0
     2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "NorthSports"   3         "-"                "-"           3           "PUB"   "Customer"       1      "Custn"                8      1       1        1        1         61     1.5          1.0
     2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "NorthSports"   3         "-"                "-"           3           "PUB"   "Customer"       1      "Name"                 9      1       1        1        1        102     2.5          1.0
     2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "NorthSports"   3         "-"                "-"           3           "PUB"   "Item"           2      "Itemn"               10      1       1        1        1         35     0.9          1.0
     2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "SouthSports"   4         "-"                "-"           4           "PUB"   "Customer"       1      "Custn"                8      1       1        1        1         43     1.1          1.0
     2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "SouthSports"   4         "-"                "-"           4           "PUB"   "Customer"       1      "Name"                 9      1       1        1        1        114     2.8          1.0
     2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "WestSports"    2         "-"                "-"           2           "PUB"   "Customer"       1      "Custn"                8      1       1        1        1         70     1.7          1.0
     2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "T"              "WestSports"    2         "-"                "-"           2           "PUB"   "Customer"       1      "Name"                 9      1       1        1        1        135     3.3          1.0
     2022-11-04T09:31:20.000-4:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2"         8       "G"              "groupItem"    -1         "-"                "-"          -1           "PUB"   "Item"           2      "Itemn"               10      1       1        1        1        503    12.4          1.0
  */
  
  define input parameter indexCSVFile as character no-undo.      /* dbanalys/<pt_shortname>.ix.txt */
  
  define variable TimeStamp       as character no-undo.
  define variable DBUID           as character no-undo.
  define variable DB_name         as character no-undo.
  define variable Area            as character no-undo.
  define variable Area#           as integer   no-undo.
  define variable PartitionType   as character no-undo.
  define variable Tenancy         as character no-undo.
  define variable Tenancy#        as integer   no-undo.
  define variable PartitionPolicy as character no-undo.
  define variable Partition       as character no-undo.
  define variable Partition#      as integer   no-undo.
  define variable IndexOwner      as character no-undo.
  define variable TableName       as character no-undo.
  define variable Table#          as integer   no-undo.
  define variable IndexName       as character no-undo.
  define variable Index#          as integer   no-undo.
  define variable State           as character no-undo.
  define variable IndexFields     as integer   no-undo.
  define variable Levels          as integer   no-undo.
  define variable Blocks          as integer   no-undo.
  define variable IndexSize       as int64     no-undo.
  define variable Utilization     as decimal   no-undo.
  define variable Factor          as decimal   no-undo.
  
  define variable TableIndex      as character no-undo.         /* tablename.indexname */
  define variable totalUtilWeight as decimal   no-undo.
  
  if dbgMode >= 2 then message now "Parsing:" indexCSVFile.
  
  /* make sure it exists */
  file-info:file-name = indexCSVFile.
  if file-info:full-pathname = ? then 
    do:
      if dbgMode >= 2 then message now substitute( "Index CSV file &1 not found.", indexCSVFile ).
      return.
    end.  

  empty temp-table ixlist.
  empty temp-table tt_MTIndex.

  input stream tba from value( indexCSVFile ).

  repeat:
    
    import stream tba
      TimeStamp      
      DBUID          
      DB_name         
      Area           
      Area#          
      PartitionType  
      Tenancy        
      Tenancy#       
      PartitionPolicy
      Partition      
      Partition#     
      IndexOwner          
      TableName          
      Table#         
      IndexName          
      Index#         
      State          
      IndexFields         
      Levels         
      Blocks         
      IndexSize           
      Utilization    
      Factor         
      no-error.
    
    /* if -verbose was used, there will be a header record with column labels that we want to skip */
    if TimeStamp = 'Time Stamp' then next.
    
    /* make sure this index is in the cache */
    find tt_idx no-lock where tt_idx.xid = Index# no-error.
    if not available( tt_idx ) then
      do:
        if dbgMode >= 2 then message now substitute( "parseIndexCSV: index # &1 &2.&3 in CSV file was not found in cache tt_idx", Index#, TableName, IndexName ).
        next.
      end.
      
    TableIndex = TableName + '.' + IndexName.
    
    find ixlist no-lock where ixlist.idx = TableIndex no-error.
    if not available( ixlist ) then
      do:
        create ixlist.
        assign
          ixlist.iid = Table#
          ixlist.idx = TableIndex
          .
      end. 
    
    /* if all partitions of a table are not in the same area, set the area name to "*" */
    if ixlist.ar <> "*" then
      do:
        if ixlist.ar <> Area then
          ixlist.ar = "*". 
      end.   
    
    ixlist.blks = ixlist.blks + Blocks.
      
    find tt_tbl no-lock where tt_tbl.xid = Table# no-error.
    if not available( tt_tbl ) then
      do:
        if dbgMode >= 2 then message now substitute( "parseIndexCSV: table # &1 &2 in CSV file was not found in cache tt_tbl", Table#, TableName ).
        next.
      end.
      
    find tblist no-lock where tblist.tbl = TableName no-error.
    if not available( tblist ) then
      do:
        if dbgMode >= 2 then message now substitute( "parseIndexCSV: table &1 in CSV file was not found in cache tblist", TableName ).
        next.
      end.
    
    if tt_tbl.isMultiTenant then
      do:
        
        find tt_MTIndex no-lock where tt_MTIndex.IdxName = TableIndex no-error.
        
        if not available( tt_MTIndex ) then
          do:
            create tt_MTIndex.
            assign tt_MTIndex.IdxName = TableIndex.
          end.  

        assign 
          tt_MTIndex.TotalSize   = tt_MTIndex.TotalSize + IndexSize
          tt_MTIndex.MaxLevels   = maximum( tt_MTIndex.MaxLevels, Levels )
          .
          
      end.   
    
    else
      do:
        assign
          ixlist.pctut = Utilization
          ixlist.lvls  = Levels
          .
      end.  
    
  end.  

  input stream tba close.  
  
  /* MT index levels: the maximum of the levels of all of its index partitions */
  /* MT index pctut : sum of index sizes for all partitions, divided by sum of all blocks * db block size */
  find _area no-lock where _area._area-number = 1 no-error.                          /* we need the database block size to calculate MT index %util */
    
  if available( _area ) then
    do:  
      for each tt_MTIndex no-lock:
        
        find ixlist no-lock where ixlist.idx = tt_MTIndex.IdxName.
        
        assign
          ixlist.lvls  = tt_MTIndex.MaxLevels
          ixlist.pctut = ( tt_MTIndex.TotalSize / ( ixlist.blks * _area._area-blocksize ) ) * 100
          .
        
      end. 
    end. 

  else
    if dbgMode >= 2 then message now substitute( "parseIndexCSV: database structure corruption: _area record for control area not found", TableName ).
  
  /* export the temp-table to <pt_shortname>.dbx */
  db_analx = substring( indexCSVFile, 1, length( indexCSVFile ) - 7 ) + '.idx'.     /* dbanalys/<pt_shortname>.idx */

  output to value( db_analx ).
  for each ixlist where ixlist.idx <> "":
    export ixlist.
  end.
  output close.  
  
end procedure.

procedure parseChainCSV:
  /* parse the chain output file from proutil dbanalys -csoutput */
  /* currently only useful as we display the RM chain block count in Table Activity */
  
  /* Example (spaces added for clarity):
     "Time Stamp"                 "DBUID"                  "DB name"  "Area" "Area #" "Partition Type" "Tenancy"     "Tenancy #" "Partition Policy" "Partition" "Partition #" "Object type" "Owner" "Object"     "Object #" "Chain Type"  "Num Blocks"
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1" 7       "-"              "-"             0         "-"                "-"           0           "Table"       "PUB"   "State"        5        "Free"         0
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1" 7       "-"              "-"             0         "-"                "-"           0           "Table"       "PUB"   "State"        5        "RM"           3
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2" 8       "G"              "groupItem"    -1         "-"                "-"          -1           "Table"       "PUB"   "Item"         2        "Free"         0
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2" 8       "G"              "groupItem"    -1         "-"                "-"          -1           "Index"       "PUB"   "Item.Itemn"  10        "Free"         3
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2" 8       "T"              "NorthSports"   3         "-"                "-"           3           "Table"       "PUB"   "Item"         2        "Free"         0
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2" 8       "T"              "NorthSports"   3         "-"                "-"           3           "Index"       "PUB"   "Item.Itemn"  10        "Free"         3
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2" 8       "G"              "groupItem"    -1         "-"                "-"          -1           "Table"       "PUB"   "Item"         2        "RM"           3
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2" 8       "T"              "NorthSports"   3         "-"                "-"           3           "Table"       "PUB"   "Item"         2        "RM"           4
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2" 8       "G"              "groupItem"    -1         "-"                "-"          -1           "Index"       "PUB"   "Item.Itemn"  10        "Index-Delete" 0
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area2" 8       "T"              "NorthSports"   3         "-"                "-"           3           "Index"       "PUB"   "Item.Itemn"  10        "Index-Delete" 0  
   */  
  define input parameter chainCSVFile as character no-undo.      /* dbanalys/<pt_shortname>.ch.txt */

  define variable TimeStamp       as character no-undo.
  define variable DBUID           as character no-undo.
  define variable DB_name         as character no-undo.
  define variable Area            as character no-undo.
  define variable Area#           as integer   no-undo.
  define variable PartitionType   as character no-undo.
  define variable Tenancy         as character no-undo.
  define variable Tenancy#        as integer   no-undo.
  define variable PartitionPolicy as character no-undo.
  define variable Partition       as character no-undo.
  define variable Partition#      as integer   no-undo.
  define variable ObjectType      as character no-undo.
  define variable ObjectOwner     as character no-undo.
  define variable ObjectName      as character no-undo.
  define variable Object#         as integer   no-undo.
  define variable ChainType       as character no-undo.
  define variable Blocks          as integer   no-undo.
  
  if dbgMode >= 2 then message now "Parsing:" chainCSVFile.
  
  /* make sure it exists */
  file-info:file-name = chainCSVFile.
  if file-info:full-pathname = ? then 
    do:
      if dbgMode >= 2 then message now substitute( "Chain CSV file &1 not found.", chainCSVFile ).
      return.
    end.  
    
  input stream tba from value( chainCSVFile ).

  repeat:
    
    import stream tba
      TimeStamp      
      DBUID          
      DB_name         
      Area           
      Area#          
      PartitionType  
      Tenancy        
      Tenancy#       
      PartitionPolicy
      Partition      
      Partition#     
      ObjectType 
      ObjectOwner
      ObjectName 
      Object#    
      ChainType  
      Blocks     
      no-error.
    
    /* if -verbose was used, there will be a header record with column labels that we want to skip */
    if TimeStamp = 'Time Stamp' then next.
  
    /* we only care about RM chain counts from tables */
    if not ( ObjectType = 'Table' and ChainType = 'RM') then next.
    
    find tblist no-lock where tblist.tbl = ObjectName no-error.
    if not available( tblist ) then
      do:
        if dbgMode >= 2 then message now substitute( "parseChainCSV: table # &1 &2 in CSV file was not found in temp-table tblist", Object#, ObjectName ).
        next.
      end.
    
    tblist.rm = tblist.rm + Blocks.
  
  end.
  
end procedure.

procedure parseLOBCSV:
  /* parse the LOB output file from proutil dbanalys -csoutput, if it exists, and populate temp-table lxlist */
  /* the CSV file <name>.lob.txt is available in OE 11.6+ */
  /* but the LOB data is only useful to us for correlation with CRUD data in OE 12.0+ */

  /* Example (spaces added for clarity):
     "Time Stamp"                  "DBUID"                  "DB name"  "Area"        "Area #" "Partition Type" "Tenancy" "Tenancy #" "Partition Policy" "Partition" "Partition #" "Owner" "Table"        "Table #" "Field"      "LOB Obj #" "LOBs" "Size" "Min"    "Max"    "Mean"
      2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Schema Area"  6       "-"              "-"        0          "-"                "-"          0            "PUB"   "_Collation"     -69     _Coll-CIData  2           0      0      0.0      0.0      0.0
      2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Schema Area"  6       "-"              "-"        0          "-"                "-"          0            "PUB"   "_Collation"     -69     _Coll-CSData  1           0      0      0.0      0.0      0.0
      2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Schema Area"  6       "-"              "-"        0          "-"                "-"          0            "PUB"   "_Collation"     -69     _Coll-CXData  3           0      0      0.0      0.0      0.0
      2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Schema Area"  6       "-"              "-"        0          "-"                "-"          0            "PUB"   "_Sysautostats" -127     _Misc         4           0      0      0.0      0.0      0.0
   */
  
  define input parameter LOBCSVFile as character no-undo.      /* dbanalys/<pt_shortname>.lob.txt */

  /* nothing to do prior to OE 12 */
  if proversion < '12' then return.

  if dbgMode >= 2 then message now "Parsing:" LOBCSVFile.
  
  /* make sure it exists */
  file-info:file-name = LOBCSVFile.
  if file-info:full-pathname = ? then 
    do:
      if dbgMode >= 2 then message now substitute( "LOB CSV file &1 not found.", LOBCSVFile ).
      return.
    end.  
    
  /* todo: read the file and do something with it! */
  
end procedure.

procedure parseBlockCSV:
  /* parse the block output file from proutil dbanalys -csoutput */

  /* Example (spaces added for clarity):
     "Time Stamp"                 "DBUID"                  "DB name"  "Area"        "Area #" "Block Type"   "Num Blocks"
     ...
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Schema Area"  6       "Free"          142
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Schema Area"  6       "Record"        212
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Schema Area"  6       "Index"         156
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Schema Area"  6       "Empty"           6
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Schema Area"  6       "Object"          1
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Schema Area"  6       "Sequence"        9
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Schema Area"  6       "Master"          1
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Schema Area"  6       "HWM"           521
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Schema Area"  6       "Total"         527
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1"        7       "Free"            1
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1"        7       "Record"          4
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1"        7       "Index"           0
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1"        7       "Empty"           0
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1"        7       "Object"          2
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1"        7       "Cluster-list"    2
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1"        7       "Object-list"     1
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1"        7       "Cluster-map"     2
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1"        7       "Block-map"       2
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1"        7       "HWM"            15
     2022-11-09T09:24:36.000-5:00 "l2Je9q3y/Z0iFHyPYD0Lpw" "sportsmt" "Area1"        7       "Total"          15
   */ 
    
  define input parameter blockCSVFile as character no-undo.      /* dbanalys/<pt_shortname>.block.txt */

  if dbgMode >= 2 then message now "Parsing:" blockCSVFile.
  
  /* make sure it exists */
  file-info:file-name = blockCSVFile.
  if file-info:full-pathname = ? then 
    do:
      if dbgMode >= 2 then message now substitute( "Block CSV file &1 not found.", blockCSVFile ).
      return.
    end.  

  /* todo: determine what to do with this data; report on block types by area? */
  
end procedure.
